/* ialntok.c */
/********************************************
* copy next word between boundaries into wbuf
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"
#include "imapalnum.h"

char *
ialntok (start, end, wbuf)
register char *start;
register char *end;
char *wbuf;
{
	register char *rp;
	char *anchor;

	if (NULCHARP (start))
		return(NULL);
	ITOEND;
	if (start == end)
		return(NULL);

	/* stop at first non-white character, drop anchor */
	for (;WHITE(*start);)
		if (++start == end)
			return(NULL);
	anchor = start;

	/* stop at first non-alnum, white, or end */
	for (rp = mapalnum; *(rp + *start);)
		if (++start == end)
			break;

	/* get a single_byte, non-alnum token; anchor and start can
	   only point to the same address if start found a
	   single-byte non-alnum token in the previous loop
	*/
	if (anchor==start)
		++start;

	/* reuse pointers */
	end = start;
	rp = wbuf;
	for (start = anchor; start < end;)
		*rp++ = *start++;
	*rp = '\0';
	return(start);
}
