/* ianytok.c */
/********************************************
* copy next word between boundaries into wbuf
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"

char *
ianytok (start, end, wbuf)
register char *start;
register char *end;
char *wbuf;
{
	register char *rp;
	char *anchor;

	if (NULCHARP (start))
		return(NULL);
	ITOEND;
	if (start == end)
		return(NULL);

	/* stop at first non-white character, drop anchor */
	for (;WHITE(*start);)
		if (++start == end)
			return(NULL);
	anchor = start;

	/* stop at first white character */
	for (;BLACK(*start);)
		if (++start == end)
			break;

	/* reuse pointers */
	end = start;
	rp = wbuf;
	for (start = anchor; start < end;)
		*rp++ = *start++;
	*rp = '\0';
	return(start);
}
