/* ibreakl.c */
/*************************************************
* split long lines into shorter ones
* Istvan Mohos, 1987 --- in the Public Domain
*************************************************/

#include "i.h"

int
ibreakl (start, end, tobuf, header, tailer, breakc, maxc, all)
char *start, *end, *tobuf, *header, *tailer, *breakc;
int maxc, all;
{
	register char *off, *top, *bc, *bp;
	int headsiz, tailsiz, segsiz;
	int newseg, remain;
	int first;

	if (NULCHARP (start))
		return (ierror ("ibreakl: null buffer"));
	ITOEND;

	if (NULCHARP (header))
		header = "";
	if (NULCHARP (tailer))
		tailer = "";

	for (off = header; *off++;);
	headsiz = --off - header;

	for (off = tailer; *off++;);
	tailsiz = --off - tailer;

	if ((segsiz = maxc - headsiz - tailsiz) < 1) {
		*tobuf = '\0';
		return (ierror ("ibreakl: impossible parameters"));
	}
	if (!all)
		first = maxc - tailsiz;

	off = end;
	remain = off - start; /* size of input */

	top = tobuf;
	bc = off = start;           /* beginning of from_buf */

	if (remain > (all ? segsiz : first)) { /* first line */
		if (!all) {
			bc += first;
			first = 0;         /* to know that full line was done */
		}
		else
			bc += segsiz;
		for (; --bc >= off;) {    /* find breakpoint */
			for (bp = breakc; *bp; bp++)
				if (*bc == *bp)
					break;        /* out of the inner loop */
			if (*bc == *bp)
				break;            /* out of the outer loop */
		}

		if (*bc != *bp) {
			*tobuf = '\0';
			return (ierror ("ibreakl: can't find breakpoint"));
		}
		newseg = ++bc - off;

		if (all)
			strcpy (top, header);
		else
			*top = '\0';
		strncat (top, off, newseg);
		strcat (top, tailer);
		for (; *top++;);
		--top;
		off += newseg;
		remain -= newseg;
	}
	else
		goto tail;

	for (;remain > segsiz;) {     /* subsequent lines */
		bc += segsiz;
		for (; --bc >= off;) {    /* find breakpoint in start */
			for (bp = breakc; *bp; bp++)
				if (*bc == *bp)
					break;        /* out of the inner loop */
			if (*bc == *bp)
				break;            /* out of the outer loop */
		}

		if (*bc != *bp) {
			*tobuf = '\0';
			return (ierror ("ibreakl: can't find breakpoint"));
		}
		newseg = ++bc - off;

		strcpy (top, header);
		strncat (top, off, newseg);
		strcat (top, tailer);
		for (;*top++;);
		--top;
		off += newseg;
		remain -= newseg;
	}

	/* copy out the reamining string */
tail:
	if (remain) {
		if (!all && first)
			*top = '\0';
		else
			strcpy (top, header);
		strcat (top, off);
		if (all)
			strcat (top, tailer);
		for (; *top++;);
		--top;
	}

	return (top - tobuf);
}
