/* icount.c */
/*****************************************************
* count how many times a specific parameter was passed
* Istvan Mohos, 1989 --- in the Public Domain
*****************************************************/

#include "i.h"

int
icount (type)
int type;
{
	static int within = 0;
	static int *mpb = NULL;
	register int *mm;

	if (type < 0) {
		if (mpb != NULL) {
			free ((char *)mpb);
			mpb = NULL;
		}
		within = 0;
		return (0);
	}
	if (type >= within) {
		errno = 0;
		if (within)
			return (ierror ("icount: arg. out of bounds"));
		if (type == 0)
			return (ierror ("icount: bad initializer"));
		if ((mpb = (int *)calloc ((unsigned)type, sizeof(int))) == NULL)
			return (ierror ("icount: calloc error"));
		within = type;
		return (0);
	}
	mm = mpb + type;
	return ((*mm)++);
}
