/* idate.c */
/********************************************
* return ptr to month/day/year string
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"

struct tm*
_igetdate()
{
	static int first = 1;
	long clock;
	static struct tm *sdate;

	if (first) {
		first = 0;
		clock = time((long *) 0);   /* seconds since 1970 */
		sdate = localtime(&clock);
	}
	return(sdate);
}

#define SHORTMO   0 /* idate format: Jun 23 1988 */
#define SHORTUPMO 1 /* idate format: JUN 23 1988 */
#define LONGMO    2 /* idate format: June 23, 1988 */
#define LONGUPMO  3 /* idate format: JUNE 23, 1988 */

char *longmo[] = {
"January",
"February",
"March",
"April",
"May",
"June",
"July",
"August",
"September",
"October",
"November",
"December"
};

char *longupmo[] = {
"JANUARY",
"FEBRUARY",
"MARCH",
"APRIL",
"MAY",
"JUNE",
"JULY",
"AUGUST",
"SEPTEMBER",
"OCTOBER",
"NOVEMBER",
"DECEMBER"
};

char *
idate (format)
int format;
{
	struct tm *ptr;
	static char mdb[32];

	ptr = _igetdate();

	switch (format) {
		case SHORTMO:
		default:
			sprintf (mdb, "%.3s %2d %d", longmo[ptr->tm_mon],
			ptr->tm_mday, 1900 + ptr->tm_year);
			return (mdb);                    /* format: 'Jun 23 1988' */

		case LONGMO:
			sprintf (mdb, "%s %2d, %d", longmo[ptr->tm_mon],
			ptr->tm_mday, 1900 + ptr->tm_year);
			return (mdb);                    /* format: June 23, 1988 */

		case SHORTUPMO:
			sprintf (mdb, "%.3s %2d %d", longupmo[ptr->tm_mon],
			ptr->tm_mday, 1900 + ptr->tm_year);
			return (mdb);                    /* format: 'JUN 23 1988' */

		case LONGUPMO:
			sprintf (mdb, "%s %2d, %d", longupmo[ptr->tm_mon],
			ptr->tm_mday, 1900 + ptr->tm_year);
			return (mdb);                    /* format: JUNE 23, 1988 */
	}
}
