/* iexpect.c */
/********************************************
* find expected first token in line
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"

int
iexpect (start, end, word, skiptok, toktype)
char *start, *end, *word, *skiptok;
int toktype;
{
	static char *(*tfunc[])() = {ianytok, ialntok, ictok};
	register char *pt, *endline;
	char token[MAXSTR];

	if (NULCHARP (start))
		return (ierror ("iexpect: null buffer"));
	ITOEND;

	if (toktype > 2 || toktype < 0)
		toktype = 0;
	if (BADCHARP(word))
		return (0);

	for (endline = start-1;;) {
		if (++endline >= end)
			return (0);
		for (pt = endline;endline < end && *endline != '\n';endline++);
		if (endline == end)
			return (0);
		/* endline now sits on newline */
		if ((*tfunc[toktype])(pt, endline, token) == NULL)
			continue;
		if (skiptok && (strcmp (token, skiptok) == 0))
			continue;
		if (strcmp (token, word) == 0)
			return (++endline - start);
		return (start - ++endline);
	 }
}

