/* ifonetic.c */
/************************************************
* convert ifonetic control strings to ASCII bytes
* Istvan Mohos, 1990 --- in the Public Domain
*************************************************/

#include "i.h"
#include "ifonetic.h"
#define  IXLEN 4 /* minimum string convertible to control byte */

int
ifonetic (start)
char *start;
{
	register char *sp = start;
	register char *tp = start;
	register char *block;
	int len;
	int alphaindex;

	if (BADCHARP(sp))
		return (0);
	if ((len = strlen (sp)) < IXLEN)
		return (len);

	for (block = sp + len - IXLEN + 1; sp < block;)
		if (*sp == 'X') {
			if ((alphaindex = find (++sp)) >= 0)
				*tp++ = mapfonet[alphaindex], sp += IXLEN-1;
			else
				*tp++ = 'X', *tp++ = *sp++;
		}
		else
			*tp++ = *sp++;

	for (block = start + len; sp < block; *tp++ = *sp++);
	if (tp != sp)
		*tp = '\0'; /* null terminate reduced string */

	return (tp - start);
}

static int
find (ccstring)
{
	register int lo, hi;
	register int m, mid;

	for (lo = 0, hi = IFONCNT -1; lo <= hi;) {
		mid = (lo + hi) >> 1;
		if ((m = strncmp (ccstring, listfonet[mid], 3)) < 0)
			hi = mid -1;
		else if (m > 0)
			lo = mid +1;
		else
			return(mid);
	}
	return (-1);
}

