/* ifrombit.c */
/************************************************
* convert between int value and binary bit string
* Istvan Mohos, 1990 --- in the Public Domain
*************************************************/

#include "i.h"

int
ifrombit (bitstring, bits, zero, one)
char *bitstring;
int bits;
register char zero, one;
{
	unsigned int val = 0;
	register char *b = bitstring;
	register char *p;

	if (bits > 32 || bits < 1)
		return (ierror ("ifrombit: bit count range: 1--32"));

	for (p = b; --bits >= 0; p++)
		if (*p != one && *p != zero)
			++p; /* skip spacing or punctuation char in bitstring */

	for (; b < p; b++ )
		if (*b == one)
			val <<= 1, val |= 1;
		else if (*b == zero)
			val <<= 1;

	return((int) val);
}

char *
itobit (val, bits, zero, one)
int val, bits;
register char zero, one;
{
	static char bitstring[33];
	unsigned int v = (unsigned int) val;
	register char *p;
	register char *b = bitstring;

	if (bits > 32 || bits < 1) {
		ierror ("itobit: bit count range: 1--32");
		return (NULL);
	}

	p = b + bits;
	for (*p = 0; --p >= b; v >>= 1)
		(v & 1) ? (*p = one) : (*p = zero);

	return(b);
}
