/* igroup.c */
/********************************************
* tell if separator is next in string list
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"
#define SPACE_LINE -1
#define LINE_ONLY   0
#define LINE_SPACE  1

int
igroup (ptr1, ptr2, modval)
register char *ptr1, *ptr2;
register int modval;
{
	static int count;
	static int member;
	static int lastline;

	if (BADCHARP (ptr1)) {
		member = 0;
		count = 0;
		lastline = 0;
		return (LINE_ONLY);
	}

	if (BADCHARP (ptr2)) {
		if (member) {                /* last member in family */
			member = 0;
			count = 0;
			lastline = 0;
			return (LINE_SPACE);
		}
		if (++count % modval == 0) { /* not family member */
			count = 0;
			lastline = 0;
			return (LINE_SPACE);
		}
		count = 0;
		lastline = 0;
		return (LINE_ONLY);
	}
	if (modval < 2)
		return (LINE_SPACE);

	if (ifamily (ptr1, ptr2)) {
		if (!member) {               /* first item in family group */
			member = 1;
			count = 1;
			if (lastline) {
				lastline = 0;
				return (SPACE_LINE);
			}
			return (LINE_ONLY);
		}
		if (++count % modval == 0) { /* intermediate family members */
			if (lastline) {
				lastline = 0;
				return (LINE_SPACE);
			}
			lastline = 1;
			return (LINE_ONLY);
		}
		lastline = 1;
		return (LINE_ONLY);
	}

	if (member) {                    /* last member in family */
		member = 0;
		count = 0;
		lastline = 0;
		return (LINE_SPACE);
	}

	if (++count % modval == 0) {     /* not family member */
		lastline = 0;
		return (LINE_SPACE);
	}

	lastline = 1;
	return (LINE_ONLY);
}
