/* ihms.c */
/********************************************
* return ptr to hh:mm:ss
* Istvan Mohos, 1987 --- in the Public Domain
********************************************/

#include "i.h"
#define DAYSEC (24 * 3600)

char *
ihms (key)
int key;
{
	static char buf[32];
	static long clock1, clock2;
	int hour, minute, second;

	if (key < 0)
		key = -1;

	switch (key) {
		case -1:
		/* seconds since 0:00:00 Greenwich Mean Time, January 1 1970 */
			clock1 = time ((long *) 0);
			return (NULL);
		case 0:
			clock2 = time ((long *) 0) - clock1;
			break;
		default:
			clock2 = (long) key;
			break;
	}

	clock2 %= DAYSEC;
	hour = clock2 / 3600;
	minute = (clock2 % 3600) / 60;
	second = clock2 % 60;
	sprintf (buf, "%.2d:%.2d:%.2d", hour, minute, second);
	return (buf);
}
