/* ilist.c */
/********************************************
* create array of pointers to items in buffer
* Istvan Mohos, 1987 --- in the Public Domain
*********************************************/

#include "i.h"

int
ilist (start, end, delims, ptrlist)
char *start, *delims;
register char *end;
char **ptrlist;
{
	register int ri;
	register int pcnt = 0;
	int toksiz;
	char *token, *savp, **work, *lag;

	if (NULCHARP(start))
		return(ierror("ilist: null buffer"));
	ITOEND;
	if (BADCHARP(delims))
		return(ierror("ilist: bad delimiters"));

	ftok(INITOKF, start, end);
	do {        /* pcnt one more than tokens found */
		++pcnt;
		ftok(ITOKF, delims, 0, &token);
	} while (token != (char *)NULL);

	if (NULCHARP(savp=malloc((unsigned int)pcnt * sizeof(char *))))
		return(ierror("ilist: can't allocate pointer array"));
	*((char **)savp + --pcnt) = NULL; /* sentinel terminator */
	work = (char **)savp;

	ftok(INITOKF, start, end);
	toksiz = ftok(ITOKF, delims, 0, &token);
	lag = token+toksiz;
	*work++ = token;

	for (ri = pcnt; --ri;) {
		toksiz = ftok(ITOKF, delims, 0, &token);
		*lag = 0;
		*work++ = token;
		lag = token+toksiz;
	}

	*ptrlist = savp;
	return(pcnt);
}

static int
ftok (context, start, Z, result)
int context;
char *start, *Z, **result;
{
	register char *rp, *past_dlm;
	register int dlmflag, tokflag;
	static char *anchor, *P, *end;

	switch (context) {
		case INITOKF: /* first call, forward */
			end = Z;
			P = start;
			return(end - start);

		case ITOKF: /* subsequent calls, forward */
		default:
			for (past_dlm = start; *past_dlm; past_dlm++);

			/* move to 1st non-delimiter byte */
			for (tokflag = 0; P < end;) {
				for (dlmflag = 0, rp = start; rp < past_dlm;)
					if (dlmflag = (*rp++ == *P)) {
						P++;
						break;   /* do not test other separators */
					}
				if (tokflag = !dlmflag)  /* found first byte of token */
					break;
			}

			if (!tokflag) {
				*result = (char *)NULL;
				return(0);
			}

			/* move past token */
			for (anchor = P; P < end; P++)
				for (rp = start; rp < past_dlm;)
					if (*rp++ == *P) {
						*result = anchor;
						return(P++ -anchor);/* most return from here */
					}

			*result = anchor; /* but no space for delimiter */
			return(end - anchor);
	}
}
