/* illistn.c */
/********************************************
* create array of pointers to lines in buffer
* Istvan Mohos, 1987 --- in the Public Domain
*********************************************/

#include "i.h"

int
illistn (start, end, ptrlist)
register char *start;
register char *end;
char **ptrlist;
{
	register int ri;
	register char *rp;
	char *savp, **work;

	if (NULCHARP (start))
		return (ierror ("illistn: null buffer"));
	ITOEND;

	if (end > start)
		*(end -1) = '\n'; /* so it can be counted */
	for (ri = 0, rp = end; --rp >= start;)
		if (*rp == '\n')
			++ri;

	if (NULCHARP(savp=malloc((unsigned int)(ri + 1) * sizeof(char *))))
		return(ierror("illistn: can't allocate pointer array"));
	work = (char **)savp + ri;
	*work = NULL; /* sentinel terminator */

	if (end > start)
		*(rp = end -1) = '\0';
	else
		rp = end;

	/* start one character to left of last byte in buffer; the address
	   of the byte to the right of the next-encountered newline
	   (parsing backwards) is the start of the current string
	*/
	if (ri) {
		for (; --rp >= start;)
			if (*rp == '\n')
				*rp = 0, *--work = rp+1;

		/* rp now pointing to start-1 */
		*--work = ++rp;
	}

	*ptrlist = savp;
	return(ri);
}
